> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Update Site Route

PUT https://api.bigcommerce.com/stores/{store_hash}/v3/sites/{site_id}/routes/{route_id}
Content-Type: application/json

Update a site’s route.


Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/sites/site-routes/update-site-route

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Channel Listings | modify | `store_channel_listings` | | Channel Listings | read-only | `store_channel_listings_read_only` | | Channel Settings | modify | `store_channel_settings` | | Channel Settings | read-only | `store_channel_settings_read_only` | | Sites & Routes | modify | `store_sites` | | Sites & Routes | read-only | `store_sites_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `site_id` (integer, required) — The ID of the site.
- `route_id` (string, required) — The ID of the site route.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a siteRoutes_Route_Base.

- `type` (enum, required) — The type of resource being routed to; [supported types](/developer/api-reference/rest/admin/management/sites#route-types).
  - Allowed values: `product`, `brand`, `category`, `page`, `blog`, `home`, `cart`, `checkout`, `search`, `account`, `login`, `returns`, `static`
- `matching` (string, required) — Depending on the resource type, this can be an ID (matching a specific item), or a "*" wildcard (matching all items of that type). For example, a route with a type: "product" and matching: "5" will be used for the product with the ID of 5.
- `route` (string, required) — The route template that will be used to generate the URL for the requested resource. Supports several tokens: * `{id}` The **ID** of the requested item. * `{slug}` The **slug** for the requested item (if available). Note: the `slug` value may contain `/` slash. * `{language}` The **language** string that the client is using.

## Response

### 201

The requested site route.

- `data` (siteRoute_Full, optional) — Route object used in responses.
- `meta` (MetaOpen, optional) — Response metadata.

## Types

### siteRoute_Full

Route object used in responses.

- `id` (integer, optional) — Unique ID for this route. Required when updating an existing route.
- `matching` (string, optional) — Depending on the resource type, this can be an ID (matching a specific item), or a "*" wildcard (matching all items of that type). For example, a route with a type: "product" and matching: "5" will be used for the product with the ID of 5.
- `route` (string, optional) — The route template that will be used to generate the URL for the requested resource. Supports several tokens: * `{id}` The **ID** of the requested item. * `{slug}` The **slug** for the requested item (if available). Note: the `slug` value may contain `/` slash. * `{language}` The **language** string that the client is using.
- `type` (enum, optional) — The type of resource being routed to; [supported types](/developer/api-reference/rest/admin/management/sites#route-types).
  - Allowed values: `product`, `brand`, `category`, `page`, `blog`, `home`, `cart`, `checkout`, `search`, `account`, `login`, `returns`, `static`

### MetaOpen

Response metadata.

## Examples

**Request**

```json
{
  "type": "product",
  "matching": "5",
  "route": "/my-amazing-product"
}
```

**Response**

```json
{
  "data": {
    "id": 123,
    "matching": "5",
    "route": "/my-amazing-product",
    "type": "checkout"
  },
  "meta": {}
}
```

**SDK Code**

```python response
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id"

payload = {
    "type": "product",
    "matching": "5",
    "route": "/my-amazing-product"
}
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id';
const options = {
  method: 'PUT',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '{"type":"product","matching":"5","route":"/my-amazing-product"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id"

	payload := strings.NewReader("{\n  \"type\": \"product\",\n  \"matching\": \"5\",\n  \"route\": \"/my-amazing-product\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"type\": \"product\",\n  \"matching\": \"5\",\n  \"route\": \"/my-amazing-product\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"type\": \"product\",\n  \"matching\": \"5\",\n  \"route\": \"/my-amazing-product\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id', [
  'body' => '{
  "type": "product",
  "matching": "5",
  "route": "/my-amazing-product"
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id");
var request = new RestRequest(Method.PUT);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"type\": \"product\",\n  \"matching\": \"5\",\n  \"route\": \"/my-amazing-product\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "type": "product",
  "matching": "5",
  "route": "/my-amazing-product"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/sites/1/routes/route_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```